ALTER TABLE NNCARDS
ADD CHARTER VARCHAR2(1 CHAR);

INSERT INTO FILE_DATA_TYPE(CODE, DESCRIPTION, INTERNAL_DESCRIPTION, ACTIVE) VALUES
('CTC', 'Charter terms and conditions', 'Charter terms and conditions', 'Y');

INSERT INTO PRINT_MODULI (MODULE_ID, OPIS, INTERNI_OPIS, CR_FILE) 
VALUES ('CHARTER_BOOKING', 'Charter booking', 'Charter booking', 'C-CharterBooking.rpt');

DROP VIEW V_PLOVILA;

CREATE OR REPLACE VIEW V_PLOVILA AS (
SELECT P.ID, P.ID_LASTNIKA, P.N_POGODBE, P.FEKALNI_TANK, P.NTIP, P.IME, P.MATICNA_LUKA, P.REGISTRSKA_N, P.NZASTAVA, P.DOLZINA, P.SIRINA, P.VISINA, P.TEZA, P.GREZ, P.PODSTAVEK, P.VALUTA, P.VREDNOST,
P.PROIZVAJALEC, P.LETO_IZDELAVE, P.KONSTRUKCIJSKI_MATERIAL, P.TIP_MOTORJA, P.MOC_MOTORJA, P.ENOTA_MOCI_MOTORJA, P.STEVILO_MOTORJEV, P.N_MOTORJA_1, P.N_MOTORJA_2, P.N_MOTORJA_3, P.ZAVAROVALNICA,
P.N_ZAVAROVALNE_POLICE, P.ZAVAROVANO_DO, P.ZAVAROVALNA_VSOTA, P.VALUTA_ZAVAROVALNE_VSOTE, P.BELEZKA, P.BELEZKA_2, P.POGODBA_OD, P.POGODBA_DO,P.TRENUTNO_OD, P.TRENUTNO_DO, P.PLOVNO_DOVOLJENJE, 
P.KRAJ_PLOVNEGA_DOVOLJENJA, P.DATUM_PLOVNEGA_DOVOLJENJA, P.N_DELOVNEGA_NALOGA, P.STORITVE,
P.USER_KREIRANJA, P.DATUM_KREIRANJA, P.USER_SPREMEMBE, P.DATUM_SPREMEMBE, P.N_ZIMOVANJE, P.DATUM_PREK_ZIMOVANJA, P.BOOKING, P.STEVILO_KABIN, P.MODEL, P.STEVILO_LEZISC, P.GORIVO, P.MOC_MOTORJA_1,
P.MOC_MOTORJA_2, P.ID_TIPA_MOTORJA_1, P.ID_TIPA_MOTORJA_2, P.ID_TIPA_MOTORJA_3, P.ENOTA_MOCI_MOTORJA_1, P.ENOTA_MOCI_MOTORJA_2, P.ENOTA_MOCI_MOTORJA_3, P.ID_PROIZVAJALCA, P.ID_KONSTR_MAT,
P.ID_PODSTAVKA, P.ID_TIPA, P.TIP_PLOVILA, P.DAT_PLOV_DOV, P.DATUM_ZAVAROVANJE, P.POOBLASTILO_DO, P.VPIS_LIST_DO, P.DATUM_MENJ_OLJA, P.DATUM_RED_SERVIS, P.ST_UR_MOTORJA, P.PROVIZIJA_DELITEV,
P.KASKO_ZAVAROVANJE_DO, P.PROVIZIJA, P.OCISCENA, P.RFID, P.PODALJSA, P.DOVOLJENJE, P.LASTNISTVO, P.ID_PLOVILA_CARINA, P.ACT, P.PLOVILA_IZVOR, P.RFIDSIGNAL, P.LAST_PORT, P.COLOR, P.ID_PRIVEZ, 
P.PROPULSION_TYPE, P.PAYMENT_TYPE, P.UNDERWATER_HULL, P.TOP_SIDES, P.DECK, P.SUPER_STRUCTURE, P.SURFACE, P.HULL_ID_NUMBER, P.VRSKUP, P.KUPCI_CREDIT_CARD_ID, P.BOAT_PRICE, P.BRUTO_TEZA, 
P.ST_POTNIKOV, P.LOADING_WEIGHT, P.LOADING_VOLUME, P.CHARTER_NNLOCATION_ID, P.FUEL_TYPE,
NT.OPIS AS NNTIP_OPIS, NT.INTERNI_OPIS AS NNTIP_INTERNI_OPIS, ND.OPIS AS NNDRZAVE_OPIS, ND.INTERNI_OPIS AS NNDRZAVE_INTERNI_OPIS, NVK.OPIS AS NNVRSKUP_OPIS, NVK.INTERNI_OPIS AS NNVRSKUP_INTERNI_OPIS,
NNL.OPIS AS NNLEZISCA_OPIS, NFT.OPIS AS FUEL_TYPE_OPIS, NMO.OPIS AS MODEL_OPIS, BERTH_TEMP.ID_PRIVEZ AS TRENUTNI_ID_PRIVEZA,
CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.OBJEKT ELSE P.TRENUTNI_OBJEKT_PRIVEZA END AS TRENUTNI_OBJEKT_PRIVEZA,
CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.N_PRIVEZA ELSE P.TRENUTNA_N_PRIVEZA END AS TRENUTNA_N_PRIVEZA,
CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.OBJEKT ELSE P.POGODBENI_OBJEKT_PRIVEZA END AS POGODBENI_OBJEKT_PRIVEZA,
CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.N_PRIVEZA ELSE P.POGODBENA_N_PRIVEZA END AS POGODBENA_N_PRIVEZA,
CASE WHEN (P.TRENUTNI_OBJEKT_PRIVEZA IS NOT NULL AND P.TRENUTNA_N_PRIVEZA IS NOT NULL AND UPPER(P.TRENUTNA_N_PRIVEZA) <> (SELECT UPPER(VREDNOST) FROM S_NASTAVITVE WHERE NAZIV = 'StartIzhod')) THEN 'Y' ELSE 'N' END AS IN_MARINA,
CASE WHEN (UPPER(P.TRENUTNA_N_PRIVEZA) = (SELECT UPPER(VREDNOST) FROM S_NASTAVITVE WHERE NAZIV = 'StartIzhod')) THEN 'Y' ELSE 'N' END AS ON_TEMPORARY_EXIT
FROM PLOVILA P
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNVRSKUP NVK ON NVK.SIFRA = P.VRSKUP
LEFT OUTER JOIN NNLEZISCA NNL ON NNL.SIFRA = P.STEVILO_LEZISC
LEFT OUTER JOIN NNFUEL_TYPE NFT ON NFT.SIFRA = P.FUEL_TYPE
LEFT OUTER JOIN NNMODEL NMO ON NMO.SIFRA = P.MODEL
LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI ASC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NULL) PRIVEZI_TEMP ON (PRIVEZI_TEMP.ID_PLOVILA = P.ID AND PRIVEZI_TEMP.RNK = 1)
LEFT OUTER JOIN NNPRIVEZ BERTH_TEMP ON BERTH_TEMP.ID_PRIVEZ = PRIVEZI_TEMP.ID_PRIVEZ
LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI DESC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NOT NULL) PRIVEZI_CONTRACT ON (PRIVEZI_CONTRACT.ID_PLOVILA = P.ID AND PRIVEZI_CONTRACT.RNK = 1)
LEFT OUTER JOIN NNPRIVEZ BERTH_CONTRACT ON BERTH_CONTRACT.ID_PRIVEZ = PRIVEZI_CONTRACT.ID_PRIVEZ
);

DROP VIEW V_REZERVACIJE;

CREATE OR REPLACE VIEW V_REZERVACIJE AS (
	SELECT R.IDPLOVILA, R.IDKUPCA, R.DATUM_OD, R.DATUM_DO, R.TIP, R.AKTIVEN, R.OPIS, R.ID_REZERVACIJE, R.PONUDBA, R.ZNESEK_PLACILA, R.ID_SALDKONT, R.VELJADO, R.ST_POGODBE, R.ZASEDENA, R.NEPLACANO, R.IDAGENCIJE, R.STATUS,
  R.USER_KREIRANJA, R.DATUM_KREIRANJA, R.USER_SPREMEMBE, R.DATUM_SPREMEMBE, P.IME AS PLOVILA_IME, P.DOLZINA AS PLOVILA_DOLZINA, P.SIRINA AS PLOVILA_SIRINA, P.MODEL AS PLOVILA_MODEL,
  K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, CS.DESCRIPTION AS STATUS_DESCRIPTION, CS.COLOR AS STATUS_COLOR, CS.TEXT_COLOR AS STATUS_TEXT_COLOR,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
	FROM REZERVACIJE R
  LEFT OUTER JOIN PLOVILA P ON P.ID = R.IDPLOVILA
  LEFT OUTER JOIN KUPCI K ON K.ID = R.IDKUPCA
  LEFT OUTER JOIN CHARTER_STATUS CS ON CS.ID_CHARTER_STATUS = R.STATUS
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1792, SYSDATE, '5.5', 1712, 'Charter booking');
